# coding: utf-8

"""
    Cachet Status Page API

    A java-friendly swagger documentation file based on the documentation for the Cachet Status Page https://cachethq.io/  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from cachethq_client.api_client import ApiClient


class ComponentsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_component(self, body, **kwargs):  # noqa: E501
        """Create a new component.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_component(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Component body: Component to be created. (required)
        :return: SingleComponentResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_component_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.create_component_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def create_component_with_http_info(self, body, **kwargs):  # noqa: E501
        """Create a new component.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_component_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Component body: Component to be created. (required)
        :return: SingleComponentResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_component" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_component`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKey']  # noqa: E501

        return self.api_client.call_api(
            '/components', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SingleComponentResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_component_by_id(self, component, **kwargs):  # noqa: E501
        """Delete a component.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_component_by_id(component, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int component: Unique component identifier. (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_component_by_id_with_http_info(component, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_component_by_id_with_http_info(component, **kwargs)  # noqa: E501
            return data

    def delete_component_by_id_with_http_info(self, component, **kwargs):  # noqa: E501
        """Delete a component.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_component_by_id_with_http_info(component, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int component: Unique component identifier. (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['component']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_component_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'component' is set
        if ('component' not in params or
                params['component'] is None):
            raise ValueError("Missing the required parameter `component` when calling `delete_component_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'component' in params:
            path_params['component'] = params['component']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKey']  # noqa: E501

        return self.api_client.call_api(
            '/components/{component}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_component_by_id(self, component, **kwargs):  # noqa: E501
        """Get a component.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_component_by_id(component, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int component: Unique component identifier. (required)
        :return: SingleComponentResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_component_by_id_with_http_info(component, **kwargs)  # noqa: E501
        else:
            (data) = self.get_component_by_id_with_http_info(component, **kwargs)  # noqa: E501
            return data

    def get_component_by_id_with_http_info(self, component, **kwargs):  # noqa: E501
        """Get a component.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_component_by_id_with_http_info(component, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int component: Unique component identifier. (required)
        :return: SingleComponentResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['component']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_component_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'component' is set
        if ('component' not in params or
                params['component'] is None):
            raise ValueError("Missing the required parameter `component` when calling `get_component_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'component' in params:
            path_params['component'] = params['component']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKey']  # noqa: E501

        return self.api_client.call_api(
            '/components/{component}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SingleComponentResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_components(self, **kwargs):  # noqa: E501
        """Get all components.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_components(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sort: Object property to filter on.
        :param str order: Ordering parameter with options of asc or desc.
        :param int per_page: Results per page.
        :param int page:
        :param int id: Unique identifier representing a specific component.
        :param str name: Full name or partial name to search for a component.
        :param int status: Unique status identifier representing a specific component status.
        :param int group_id: Unique group identifier representing a specific component group.
        :param bool enabled:
        :return: ListComponentsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_components_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_components_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_components_with_http_info(self, **kwargs):  # noqa: E501
        """Get all components.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_components_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sort: Object property to filter on.
        :param str order: Ordering parameter with options of asc or desc.
        :param int per_page: Results per page.
        :param int page:
        :param int id: Unique identifier representing a specific component.
        :param str name: Full name or partial name to search for a component.
        :param int status: Unique status identifier representing a specific component status.
        :param int group_id: Unique group identifier representing a specific component group.
        :param bool enabled:
        :return: ListComponentsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sort', 'order', 'per_page', 'page', 'id', 'name', 'status', 'group_id', 'enabled']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_components" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order' in params:
            query_params.append(('order', params['order']))  # noqa: E501
        if 'per_page' in params:
            query_params.append(('per_page', params['per_page']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'id' in params:
            query_params.append(('id', params['id']))  # noqa: E501
        if 'name' in params:
            query_params.append(('name', params['name']))  # noqa: E501
        if 'status' in params:
            query_params.append(('status', params['status']))  # noqa: E501
        if 'group_id' in params:
            query_params.append(('group_id', params['group_id']))  # noqa: E501
        if 'enabled' in params:
            query_params.append(('enabled', params['enabled']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKey']  # noqa: E501

        return self.api_client.call_api(
            '/components', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ListComponentsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_component_by_id(self, body, component, **kwargs):  # noqa: E501
        """Update a component.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_component_by_id(body, component, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Component body: Component data to be updated (required)
        :param int component: Unique component identifier. (required)
        :return: SingleComponentResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_component_by_id_with_http_info(body, component, **kwargs)  # noqa: E501
        else:
            (data) = self.update_component_by_id_with_http_info(body, component, **kwargs)  # noqa: E501
            return data

    def update_component_by_id_with_http_info(self, body, component, **kwargs):  # noqa: E501
        """Update a component.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_component_by_id_with_http_info(body, component, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Component body: Component data to be updated (required)
        :param int component: Unique component identifier. (required)
        :return: SingleComponentResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'component']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_component_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_component_by_id`")  # noqa: E501
        # verify the required parameter 'component' is set
        if ('component' not in params or
                params['component'] is None):
            raise ValueError("Missing the required parameter `component` when calling `update_component_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'component' in params:
            path_params['component'] = params['component']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKey']  # noqa: E501

        return self.api_client.call_api(
            '/components/{component}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SingleComponentResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
